searchNodes=[{"doc":"Ecto Shorts is a library created to help shorten ecto interactions and remove most of the related code. There are 2 main modules Actions and CommonChanges Actions EctoShorts.Actions allows for filters to be constructed from data such as Actions . all ( User , %{ favorite_food : &quot;curry&quot; , age : %{ gte : 18 , lte : 50 } , name : %{ ilike : &quot;steven&quot; } , preload : [ :address ] , last : 5 } ) which the equivelent would be Repo . all from u in User , preload : [ :address ] , limit : 5 , where : u . favorite_food == &quot;curry&quot; and u . age &gt;= 18 and u . age &lt;= 50 and ilike ( u . name , &quot;%steven%&quot; ) All actions can accept an optional argument of a keyword list that can be used to configure which Repo the Action should use. Options :repo - A module that uses the Ecto.Repo Module. :replica - If you don't want to perform any reads against your Primary, you can specify a replica to read from. See EctoShorts.CommonFilters for more info on filters CommonChanges EctoShorts.CommonChanges is responsible for updating relations on schemas it allows you to update associations or create using changesets and handles choosing between put_assoc and cast_assoc Actions . update ( User , 1 , %{ friends : [ %{ id : 5 , name : &quot;Billy&quot; } ] } ) Actions . update ( User , 1 , %{ friends : [ %{ id : 5 , name : &quot;Bob&quot; } ] } ) Another feature is you can update many to many relationship members using a id list of members How to make user 1 friends with users 5, 6, 7 Actions . update ( User , 1 , %{ friends : [ %{ id : 5 } , %{ id : 6 } , %{ id : 7 } ] } ) Config You can configure both the Repo and Error module via config :ecto_shorts , repo : MyRepo , error_module : EctoShorts.Actions.Error","ref":"EctoShorts.html","title":"EctoShorts","type":"module"},{"doc":"","ref":"EctoShorts.Config.html","title":"EctoShorts.Config","type":"module"},{"doc":"","ref":"EctoShorts.Config.html#repo/0","title":"EctoShorts.Config.repo/0","type":"function"},{"doc":"Actions for CRUD in ecto, these can be used by all schemas/queries","ref":"EctoShorts.Actions.html","title":"EctoShorts.Actions","type":"module"},{"doc":"","ref":"EctoShorts.Actions.html#aggregate/5","title":"EctoShorts.Actions.aggregate/5","type":"function"},{"doc":"Gets a collection of schemas from the database Examples iex&gt; EctoSchemas.Actions . all ( EctoSchemas.Accounts.User ) [ ]","ref":"EctoShorts.Actions.html#all/1","title":"EctoShorts.Actions.all/1","type":"function"},{"doc":"Gets a collection of schemas from the database but allows for a filter or an options list. Options :repo - A module that uses the Ecto.Repo Module. Examples iex&gt; Enum . each ( 1 .. 4 , fn _ -&gt; create_user ( ) end ) iex&gt; length ( EctoSchemas.Actions . all ( EctoSchemas.Accounts.User , first : 3 ) ) === 3 true iex&gt; Enum . each ( 1 .. 4 , fn _ -&gt; create_user ( ) end ) iex&gt; length ( EctoSchemas.Actions . all ( EctoSchemas.Accounts.User , repo : MyApp.MyRepoModule.Repo ) ) === 3 true","ref":"EctoShorts.Actions.html#all/2","title":"EctoShorts.Actions.all/2","type":"function"},{"doc":"Similar to all/2 but can also accept a keyword options list. Options :repo - A module that uses the Ecto.Repo Module. Examples iex&gt; Enum.each(1..4, fn _ -&gt; create_user() end) iex&gt; length(EctoSchemas.Actions.all(EctoSchemas.Accounts.User, first: 3, repo: MyApp.MyRepoModule.Repo)) === 3 true","ref":"EctoShorts.Actions.html#all/3","title":"EctoShorts.Actions.all/3","type":"function"},{"doc":"Creates a schema with given params. Can also accept a keyword options list. Options :repo - A module that uses the Ecto.Repo Module. Examples iex&gt; { :ok , schema } = EctoSchemas.Actions . create ( EctoSchemas.Accounts.User , user_params ( first_name : &quot;TEST&quot; ) ) iex&gt; schema . first_name &quot;TEST&quot; iex&gt; { :error , changeset } = EctoSchemas.Actions . create ( EctoSchemas.Accounts.User , Map . delete ( user_params ( ) , :first_name ) ) iex&gt; &quot;can&#39;t be blank&quot; in errors_on ( changeset ) . first_name true Examples iex&gt; { :ok , schema } = EctoSchemas.Actions . create ( EctoSchemas.Accounts.User , user_params ( first_name : &quot;TEST&quot; ) , repo : MyApp.MyRepoModule.Repo ) iex&gt; schema . first_name true","ref":"EctoShorts.Actions.html#create/3","title":"EctoShorts.Actions.create/3","type":"function"},{"doc":"Deletes a schema Examples iex&gt; user = create_user ( ) iex&gt; { :ok , schema } = EctoSchemas.Actions . delete ( user ) iex&gt; schema . first_name === user . first_name true","ref":"EctoShorts.Actions.html#delete/1","title":"EctoShorts.Actions.delete/1","type":"function"},{"doc":"Similar to delete/1 but can also accept a keyword options list. Options :repo - A module that uses the Ecto.Repo Module. Examples iex&gt; user = create_user ( ) iex&gt; { :ok , schema } = EctoSchemas.Actions . delete ( user , repo : MyApp.MyRepoModule.Repo ) iex&gt; schema . first_name === user . first_name true","ref":"EctoShorts.Actions.html#delete/2","title":"EctoShorts.Actions.delete/2","type":"function"},{"doc":"Deletes a schema. Can also accept a keyword options list. Options :repo - A module that uses the Ecto.Repo Module. Examples iex&gt; user = create_user ( ) iex&gt; { :ok , schema } = EctoSchemas.Actions . delete ( EctoSchemas.Accounts.User , user . id ) iex&gt; schema . first_name === user . first_name true iex&gt; user = create_user ( ) iex&gt; { :ok , schema } = EctoSchemas.Actions . delete ( EctoSchemas.Accounts.User , user . id ) iex&gt; schema . first_name === user . first_name true","ref":"EctoShorts.Actions.html#delete/3","title":"EctoShorts.Actions.delete/3","type":"function"},{"doc":"Finds a schema with matching params. Can also accept a keyword options list. Options :repo - A module that uses the Ecto.Repo Module. Examples iex&gt; user = create_user ( ) iex&gt; { :ok , schema } = EctoSchemas.Actions . find ( EctoSchemas.Accounts.User , first_name : user . first_name ) iex&gt; schema . first_name === user . first_name true iex&gt; user = create_user ( ) iex&gt; { :ok , schema } = EctoSchemas.Actions . find ( EctoSchemas.Accounts.User , first_name : user . first_name , repo : MyApp.MyRepoModule.Repo ) iex&gt; schema . first_name === user . first_name true","ref":"EctoShorts.Actions.html#find/3","title":"EctoShorts.Actions.find/3","type":"function"},{"doc":"Finds a schema by params and updates it or creates with results of params/update_params merged. Can also accept a keyword options list. Note: Relational filtering doesn't work on this function Options :repo - A module that uses the Ecto.Repo Module. :replica - If you don't want to perform any reads against your Primary, you can specify a replica to read from. Examples iex&gt; { :ok , schema } = EctoSchemas.Actions . find_and_update ( EctoSchemas.Accounts.User , %{ email : &quot;some_email&quot; } , %{ name : &quot;great name&quot; } ) iex&gt; { :ok , schema } = EctoSchemas.Actions . find_and_update ( EctoSchemas.Accounts.User , %{ email : &quot;some_email&quot; } , %{ name : &quot; great name } , repo : MyApp.MyRepoModule.Repo , replica : MyApp.MyRepoModule.Repo . replica ( ) )","ref":"EctoShorts.Actions.html#find_and_update/4","title":"EctoShorts.Actions.find_and_update/4","type":"function"},{"doc":"Finds a schema by params or creates one if it isn't found. Can also accept a keyword options list. Note: Relational filtering doesn't work on this function Options :repo - A module that uses the Ecto.Repo Module. :replica - If you don't want to perform any reads against your Primary, you can specify a replica to read from. Examples iex&gt; { :ok , schema } = EctoSchemas.Actions . find_or_create ( EctoSchemas.Accounts.User , %{ name : &quot;great name&quot; } ) iex&gt; { :ok , schema } = EctoSchemas.Actions . find_or_create ( EctoSchemas.Accounts.User , %{ name : &quot;great name&quot; } , repo : MyApp.MyRepoModule.Repo , replica : MyApp.MyRepoModule.Repo . replica ( ) )","ref":"EctoShorts.Actions.html#find_or_create/3","title":"EctoShorts.Actions.find_or_create/3","type":"function"},{"doc":"Accepts a list of schemas and attempts to find them in the DB. Any missing Schemas will be created. Can also accept a keyword options list. Note: Relational filtering doesn't work on this function Options :repo - A module that uses the Ecto.Repo Module. :replica - If you don't want to perform any reads against your Primary, you can specify a replica to read from. Examples iex&gt; {:ok, records} = EctoSchemas.Actions.find_or_create_many(EctoSchemas.Accounts.User, [%{name: &quot;foo&quot;}, %{name: &quot;bar}]) iex&gt; length(records) === 2","ref":"EctoShorts.Actions.html#find_or_create_many/3","title":"EctoShorts.Actions.find_or_create_many/3","type":"function"},{"doc":"Gets a schema from the database Examples iex&gt; user = create_user ( ) iex&gt; %{ id : id } = EctoSchemas.Actions . get ( EctoSchemas.Accounts.User , user . id ) iex&gt; id === user . id true iex&gt; EctoSchemas.Actions . get ( EctoSchemas.Accounts.User , 2504390 ) # ID nonexistant nil","ref":"EctoShorts.Actions.html#get/3","title":"EctoShorts.Actions.get/3","type":"function"},{"doc":"Gets a collection of schemas from the database but allows for a filter","ref":"EctoShorts.Actions.html#stream/3","title":"EctoShorts.Actions.stream/3","type":"function"},{"doc":"Updates a schema with given updates. Can also accept a keyword options list. Options :repo - A module that uses the Ecto.Repo Module. :replica - If you don't want to perform any reads against your Primary, you can specify a replica to read from. Examples iex&gt; user = create_user ( ) iex&gt; { :ok , schema } = EctoSchemas.Actions . update ( EctoSchemas.Accounts.User , user , first_name : user . first_name ) iex&gt; schema . first_name === user . first_name true iex&gt; user = create_user ( ) iex&gt; { :ok , schema } = EctoSchemas.Actions . update ( EctoSchemas.Accounts.User , 1 , first_name : user . first_name , repo : MyApp.MyRepoModule.Repo , replica : MyApp.MyRepoModule.Repo . replica ( ) ) iex&gt; schema . first_name === user . first_name true","ref":"EctoShorts.Actions.html#update/4","title":"EctoShorts.Actions.update/4","type":"function"},{"doc":"","ref":"EctoShorts.Actions.html#t:aggregate_options/0","title":"EctoShorts.Actions.aggregate_options/0","type":"type"},{"doc":"","ref":"EctoShorts.Actions.html#t:filter_params/0","title":"EctoShorts.Actions.filter_params/0","type":"type"},{"doc":"","ref":"EctoShorts.Actions.html#t:query/0","title":"EctoShorts.Actions.query/0","type":"type"},{"doc":"","ref":"EctoShorts.Actions.html#t:schema_list/0","title":"EctoShorts.Actions.schema_list/0","type":"type"},{"doc":"","ref":"EctoShorts.Actions.html#t:schema_res/0","title":"EctoShorts.Actions.schema_res/0","type":"type"},{"doc":"This module is responsible for determining put/cast assoc as well as creating and updating model relations","ref":"EctoShorts.CommonChanges.html","title":"EctoShorts.CommonChanges","type":"module"},{"doc":"Checks if field on changeset is empty list in data or changes","ref":"EctoShorts.CommonChanges.html#changeset_field_empty?/2","title":"EctoShorts.CommonChanges.changeset_field_empty?/2","type":"function"},{"doc":"Checks if field on changeset is nil in data or changes","ref":"EctoShorts.CommonChanges.html#changeset_field_nil?/2","title":"EctoShorts.CommonChanges.changeset_field_nil?/2","type":"function"},{"doc":"","ref":"EctoShorts.CommonChanges.html#default_opts/0","title":"EctoShorts.CommonChanges.default_opts/0","type":"function"},{"doc":"","ref":"EctoShorts.CommonChanges.html#preload_change_assoc/2","title":"EctoShorts.CommonChanges.preload_change_assoc/2","type":"function"},{"doc":"This function is the primary use function Preloads changeset assoc if change is made and then and put_or_cast's it Example iex&gt; CommonChanges.preload_change_assoc(changeset, :my_relation) iex&gt; CommonChanges.preload_change_assoc(changeset, :my_relation, repo: MyApp.OtherRepo) iex&gt; CommonChanges.preload_change_assoc(changeset, :my_relation, required: true)","ref":"EctoShorts.CommonChanges.html#preload_change_assoc/3","title":"EctoShorts.CommonChanges.preload_change_assoc/3","type":"function"},{"doc":"Preloads a changesets association","ref":"EctoShorts.CommonChanges.html#preload_changeset_assoc/3","title":"EctoShorts.CommonChanges.preload_changeset_assoc/3","type":"function"},{"doc":"Determines put or cast on association with some special magic If you pass a many to many relation only a list of id's it will count that as a member_update and remove or add members to the relations list E.G. User many_to_many Fruit This would update the user to have only fruits with id 1 and 3 CommonChanges . put_or_cast_assoc ( change ( user , fruits : [ %{ id : 1 } , %{ id : 3 } ] ) , :fruits )","ref":"EctoShorts.CommonChanges.html#put_or_cast_assoc/3","title":"EctoShorts.CommonChanges.put_or_cast_assoc/3","type":"function"},{"doc":"Run's changeset function if when function returns true","ref":"EctoShorts.CommonChanges.html#put_when/3","title":"EctoShorts.CommonChanges.put_when/3","type":"function"},{"doc":"This modules main purpose is to house a collection of common schema filters and functionality to be included in params -&gt; filters Common filters available include preload - Preloads fields onto the query results start_date - Query for items inserted after this date end_date - Query for items inserted before this date before - Get items with ID's before this value after - Get items with ID's after this value ids - Get items with a list of ids first - Gets the first n items last - Gets the last n items limit - Gets the first n items offset - Offsets limit by n items order_by - orders the results in desc or asc order search - Warning: This requires schemas using this to have a &amp;by_search(query, val) function You are also able to filter on any natural field of a model, as well as use gte/gt lte/lt like/ilike is_nil/not(is_nil) CommonFilters . convert_params_to_filter ( User , %{ name : %{ ilike : &quot;steve&quot; } } ) CommonFilters . convert_params_to_filter ( User , %{ name : %{ age : %{ gte : 18 , lte : 30 } } } ) CommonFilters . convert_params_to_filter ( User , %{ name : %{ is_banned : %{ != : nil } } } ) CommonFilters . convert_params_to_filter ( User , %{ name : %{ is_banned : %{ == : nil } } } ) CommonFilters . convert_params_to_filter ( User , %{ name : %{ balance : %{ != : 0 } } } ) CommonFilters . convert_params_to_filter ( User , %{ name : &quot;Billy&quot; } )","ref":"EctoShorts.CommonFilters.html","title":"EctoShorts.CommonFilters","type":"module"},{"doc":"Converts filter params into a query","ref":"EctoShorts.CommonFilters.html#convert_params_to_filter/2","title":"EctoShorts.CommonFilters.convert_params_to_filter/2","type":"function"},{"doc":"","ref":"EctoShorts.CommonFilters.html#create_schema_filter/2","title":"EctoShorts.CommonFilters.create_schema_filter/2","type":"function"},{"doc":"Module that has helpers that are globably useful on ecto schemas","ref":"EctoShorts.SchemaHelpers.html","title":"EctoShorts.SchemaHelpers","type":"module"},{"doc":"Determine if all items in list has been created or not Example iex&gt; SchemaHelpers.all_created?([%{id: 2}, %{&quot;id&quot; =&gt; 5}]) true iex&gt; SchemaHelpers.all_created?([%{&quot;id&quot; =&gt; 2}, %{item: 3}]) false","ref":"EctoShorts.SchemaHelpers.html#all_created?/1","title":"EctoShorts.SchemaHelpers.all_created?/1","type":"function"},{"doc":"Determine if all items in list are a schema Example iex&gt; SchemaHelpers.all_schemas([%{some_map: 1}, create_schema()]) false iex&gt; SchemaHelpers.all_schemas([create_schema(), create_schema()]) true","ref":"EctoShorts.SchemaHelpers.html#all_schemas?/1","title":"EctoShorts.SchemaHelpers.all_schemas?/1","type":"function"},{"doc":"Determine if any items in list has been created or not Example iex&gt; SchemaHelpers.any_created?([%{id: 2}, %{&quot;id&quot; =&gt; 5}]) true iex&gt; SchemaHelpers.any_created?([%{&quot;id&quot; =&gt; 2}, %{item: 3}]) true iex&gt; SchemaHelpers.any_created?([%{test: 3}, %{item: 3}]) false","ref":"EctoShorts.SchemaHelpers.html#any_created?/1","title":"EctoShorts.SchemaHelpers.any_created?/1","type":"function"},{"doc":"Determine if item has been created or not Example iex&gt; SchemaHelpers.created?(%{id: 2}) true iex&gt; SchemaHelpers.created?(%{&quot;id&quot; =&gt; 2}) true iex&gt; SchemaHelpers.created?(%{item: 3}) false","ref":"EctoShorts.SchemaHelpers.html#created?/1","title":"EctoShorts.SchemaHelpers.created?/1","type":"function"},{"doc":"Determine if any items in list are a schema Example iex&gt; SchemaHelpers.has_schemas?([%{some_map: 1}, create_schema()]) true iex&gt; SchemaHelpers.has_schemas?([%{some_map: 1}]) false","ref":"EctoShorts.SchemaHelpers.html#has_schemas?/1","title":"EctoShorts.SchemaHelpers.has_schemas?/1","type":"function"},{"doc":"Determine if item passed in is a Ecto Schema Example iex&gt; SchemaHelpers.schema?(create_schema()) true iex&gt; SchemaHelpers.schema?(%{some_map: 1}) false iex&gt; SchemaHelpers.schema?([create_schema()]) false","ref":"EctoShorts.SchemaHelpers.html#schema?/1","title":"EctoShorts.SchemaHelpers.schema?/1","type":"function"},{"doc":"This module generates errors from actions it can be overridden by config by setting error module Errors from Actions: [:not_found, :bad_request, :internal_server_error]","ref":"EctoShorts.Actions.Error.html","title":"EctoShorts.Actions.Error","type":"behaviour"},{"doc":"","ref":"EctoShorts.Actions.Error.html#call/3","title":"EctoShorts.Actions.Error.call/3","type":"function"},{"doc":"","ref":"EctoShorts.Actions.Error.html#create_error/3","title":"EctoShorts.Actions.Error.create_error/3","type":"function"},{"doc":"","ref":"EctoShorts.Actions.Error.html#c:create_error/3","title":"EctoShorts.Actions.Error.create_error/3","type":"callback"},{"doc":"","ref":"EctoShorts.Actions.Error.html#error_module/0","title":"EctoShorts.Actions.Error.error_module/0","type":"function"},{"doc":"","ref":"EctoShorts.Actions.Error.html#t:t/0","title":"EctoShorts.Actions.Error.t/0","type":"type"},{"doc":"Behaviour for query building from filter tuples","ref":"EctoShorts.QueryBuilder.html","title":"EctoShorts.QueryBuilder","type":"behaviour"},{"doc":"Adds to accumulator query with filter_type and value","ref":"EctoShorts.QueryBuilder.html#c:create_schema_filter/2","title":"EctoShorts.QueryBuilder.create_schema_filter/2","type":"callback"},{"doc":"","ref":"EctoShorts.QueryBuilder.html#create_schema_filter/3","title":"EctoShorts.QueryBuilder.create_schema_filter/3","type":"function"},{"doc":"Pulls the schema from a query","ref":"EctoShorts.QueryBuilder.html#query_schema/1","title":"EctoShorts.QueryBuilder.query_schema/1","type":"function"},{"doc":"","ref":"EctoShorts.QueryBuilder.html#t:accumulator_query/0","title":"EctoShorts.QueryBuilder.accumulator_query/0","type":"type"},{"doc":"","ref":"EctoShorts.QueryBuilder.html#t:filter_tuple/0","title":"EctoShorts.QueryBuilder.filter_tuple/0","type":"type"},{"doc":"This module contains query building parts for common things such as preload, start/end date and others","ref":"EctoShorts.QueryBuilder.Common.html","title":"EctoShorts.QueryBuilder.Common","type":"module"},{"doc":"","ref":"EctoShorts.QueryBuilder.Common.html#filters/0","title":"EctoShorts.QueryBuilder.Common.filters/0","type":"function"},{"doc":"This module contains query building parts for schemas themselves, when passed a query it can pull the schema from it and attempt to filter on any natural field","ref":"EctoShorts.QueryBuilder.Schema.html","title":"EctoShorts.QueryBuilder.Schema","type":"module"},{"doc":"","ref":"EctoShorts.QueryBuilder.Schema.html#create_schema_filter/3","title":"EctoShorts.QueryBuilder.Schema.create_schema_filter/3","type":"function"}]